package edu.brown.benchmark.wikipedia.data;

import edu.brown.statistics.ObjectHistogram;

public abstract class RevisionHistograms {

    /**
     * The length of the REV_COMMENT column
     */
    public static final ObjectHistogram<Integer> COMMENT_LENGTH = new ObjectHistogram<Integer>() {
        {
            this.put(0, 369676);
            this.put(1, 2349);
            this.put(2, 6499);
            this.put(3, 15283);
            this.put(4, 12587);
            this.put(5, 9478);
            this.put(6, 8950);
            this.put(7, 15733);
            this.put(8, 17814);
            this.put(9, 13030);
            this.put(10, 20114);
            this.put(11, 23820);
            this.put(12, 37709);
            this.put(13, 33519);
            this.put(14, 32407);
            this.put(15, 28522);
            this.put(16, 32136);
            this.put(17, 28346);
            this.put(18, 23220);
            this.put(19, 26814);
            this.put(20, 44981);
            this.put(21, 22521);
            this.put(22, 21283);
            this.put(23, 20584);
            this.put(24, 20573);
            this.put(25, 20744);
            this.put(26, 21000);
            this.put(27, 16677);
            this.put(28, 18865);
            this.put(29, 17696);
            this.put(30, 15825);
            this.put(31, 17675);
            this.put(32, 14153);
            this.put(33, 16588);
            this.put(34, 14771);
            this.put(35, 14556);
            this.put(36, 14078);
            this.put(37, 11642);
            this.put(38, 11149);
            this.put(39, 10627);
            this.put(40, 10310);
            this.put(41, 8686);
            this.put(42, 11333);
            this.put(43, 8712);
            this.put(44, 8030);
            this.put(45, 8106);
            this.put(46, 7814);
            this.put(47, 8776);
            this.put(48, 7439);
            this.put(49, 6503);
            this.put(50, 6323);
            this.put(51, 5874);
            this.put(52, 6472);
            this.put(53, 6024);
            this.put(54, 7171);
            this.put(55, 5338);
            this.put(56, 6252);
            this.put(57, 5208);
            this.put(58, 5260);
            this.put(59, 4390);
            this.put(60, 4723);
            this.put(61, 4467);
            this.put(62, 5498);
            this.put(63, 4129);
            this.put(64, 3989);
            this.put(65, 3594);
            this.put(66, 4851);
            this.put(67, 3588);
            this.put(68, 3825);
            this.put(69, 3705);
            this.put(70, 3212);
            this.put(71, 3124);
            this.put(72, 3775);
            this.put(73, 2853);
            this.put(74, 2969);
            this.put(75, 2785);
            this.put(76, 2796);
            this.put(77, 3964);
            this.put(78, 2514);
            this.put(79, 2493);
            this.put(80, 2955);
            this.put(81, 3000);
            this.put(82, 2916);
            this.put(83, 2223);
            this.put(84, 2247);
            this.put(85, 2489);
            this.put(86, 1892);
            this.put(87, 2705);
            this.put(88, 3226);
            this.put(89, 1994);
            this.put(90, 1852);
            this.put(91, 2070);
            this.put(92, 2066);
            this.put(93, 2371);
            this.put(94, 1961);
            this.put(95, 1803);
            this.put(96, 2305);
            this.put(97, 1812);
            this.put(98, 2145);
            this.put(99, 2203);
            this.put(100, 1837);
            this.put(101, 1799);
            this.put(102, 1726);
            this.put(103, 1730);
            this.put(104, 1890);
            this.put(105, 1688);
            this.put(106, 1478);
            this.put(107, 1659);
            this.put(108, 1396);
            this.put(109, 2088);
            this.put(110, 1772);
            this.put(111, 1158);
            this.put(112, 1234);
            this.put(113, 1756);
            this.put(114, 1417);
            this.put(115, 1173);
            this.put(116, 1480);
            this.put(117, 1447);
            this.put(118, 1640);
            this.put(119, 1910);
            this.put(120, 1851);
            this.put(121, 1699);
            this.put(122, 1994);
            this.put(123, 1464);
            this.put(124, 1504);
            this.put(125, 3023);
            this.put(126, 1779);
            this.put(127, 1572);
            this.put(128, 3420);
            this.put(129, 1463);
            this.put(130, 1637);
            this.put(131, 2772);
            this.put(132, 1751);
            this.put(133, 2315);
            this.put(134, 2190);
            this.put(135, 1690);
            this.put(136, 1889);
            this.put(137, 2412);
            this.put(138, 1839);
            this.put(139, 1665);
            this.put(140, 1512);
            this.put(141, 1267);
            this.put(142, 1543);
            this.put(143, 1057);
            this.put(144, 961);
            this.put(145, 1019);
            this.put(146, 835);
            this.put(147, 835);
            this.put(148, 914);
            this.put(149, 726);
            this.put(150, 688);
            this.put(151, 598);
            this.put(152, 786);
            this.put(153, 610);
            this.put(154, 702);
            this.put(155, 925);
            this.put(156, 739);
            this.put(157, 804);
            this.put(158, 578);
            this.put(159, 531);
            this.put(160, 555);
            this.put(161, 629);
            this.put(162, 532);
            this.put(163, 543);
            this.put(164, 548);
            this.put(165, 568);
            this.put(166, 616);
            this.put(167, 503);
            this.put(168, 596);
            this.put(169, 535);
            this.put(170, 614);
            this.put(171, 538);
            this.put(172, 479);
            this.put(173, 513);
            this.put(174, 613);
            this.put(175, 447);
            this.put(176, 488);
            this.put(177, 436);
            this.put(178, 497);
            this.put(179, 438);
            this.put(180, 490);
            this.put(181, 385);
            this.put(182, 440);
            this.put(183, 409);
            this.put(184, 509);
            this.put(185, 343);
            this.put(186, 483);
            this.put(187, 405);
            this.put(188, 401);
            this.put(189, 362);
            this.put(190, 462);
            this.put(191, 336);
            this.put(192, 433);
            this.put(193, 423);
            this.put(194, 345);
            this.put(195, 439);
            this.put(196, 393);
            this.put(197, 580);
            this.put(198, 581);
            this.put(199, 5151);
            this.put(200, 1201);
            this.put(201, 64);
            this.put(202, 56);
            this.put(203, 56);
            this.put(204, 43);
            this.put(205, 35);
            this.put(206, 41);
            this.put(207, 62);
            this.put(208, 66);
            this.put(209, 68);
            this.put(210, 82);
            this.put(211, 78);
            this.put(212, 50);
            this.put(213, 63);
            this.put(214, 59);
            this.put(215, 76);
            this.put(216, 76);
            this.put(217, 43);
            this.put(218, 38);
            this.put(219, 27);
            this.put(220, 36);
            this.put(221, 35);
            this.put(222, 37);
            this.put(223, 45);
            this.put(224, 32);
            this.put(225, 40);
            this.put(226, 30);
            this.put(227, 27);
            this.put(228, 16);
            this.put(229, 17);
            this.put(230, 18);
            this.put(231, 18);
            this.put(232, 11);
            this.put(233, 11);
            this.put(234, 21);
            this.put(235, 12);
            this.put(236, 11);
            this.put(237, 14);
            this.put(238, 10);
            this.put(239, 19);
            this.put(240, 11);
            this.put(241, 14);
            this.put(242, 8);
            this.put(243, 55);
            this.put(244, 19);
            this.put(245, 36);
            this.put(246, 35);
            this.put(247, 53);
            this.put(248, 96);
            this.put(249, 101);
            this.put(250, 173);
            this.put(251, 138);
            this.put(252, 110);
            this.put(253, 135);
            this.put(254, 34);
            this.put(255, 232);
        }
    };
    
    /**
     * 
     */
    public static final int REVISION_DELTA_SIZES[] = { 1000, 10000, 100000 };
    
    /**
     * 
     */
    @SuppressWarnings("unchecked")
    public static final ObjectHistogram<Integer> REVISION_DELTAS[] = (ObjectHistogram<Integer>[])new ObjectHistogram[] {
        new ObjectHistogram<Integer>() {
            {
                this.put(-1000, 237);
                this.put(-900, 237);
                this.put(-800, 252);
                this.put(-700, 357);
                this.put(-600, 411);
                this.put(-500, 538);
                this.put(-400, 726);
                this.put(-300, 1058);
                this.put(-200, 1795);
                this.put(-100, 7579);
                this.put(0, 121517);
                this.put(100, 40064);
                this.put(200, 11512);
                this.put(300, 7300);
                this.put(400, 4931);
                this.put(500, 3367);
                this.put(600, 2592);
                this.put(700, 1957);
                this.put(800, 1495);
                this.put(900, 1169);
                this.put(1000, 1210);
                this.put(1100, 750);
                this.put(1200, 545);
                this.put(1300, 570);
                this.put(1400, 657);
                this.put(1500, 461);
                this.put(1600, 348);
                this.put(1700, 635);
                this.put(1800, 421);
                this.put(1900, 233);
                this.put(2000, 243);
                this.put(2100, 193);
                this.put(2200, 167);
                this.put(2300, 159);
                this.put(2400, 148);
                this.put(2500, 123);
                this.put(2600, 96);
                this.put(2700, 124);
                this.put(2800, 106);
                this.put(2900, 93);
                this.put(3000, 66);
                this.put(3100, 91);
                this.put(3200, 93);
                this.put(3300, 74);
                this.put(3400, 90);
                this.put(3500, 67);
                this.put(3600, 76);
                this.put(3700, 59);
                this.put(3800, 53);
                this.put(3900, 69);
                this.put(4000, 68);
                this.put(4100, 59);
                this.put(4200, 47);
                this.put(4300, 44);
                this.put(4400, 55);
                this.put(4500, 37);
                this.put(4600, 39);
                this.put(4700, 56);
                this.put(4800, 41);
                this.put(4900, 46);
                this.put(5000, 47);
                this.put(5100, 39);
                this.put(5200, 39);
                this.put(5300, 43);
                this.put(5400, 54);
                this.put(5500, 41);
                this.put(5600, 17);
                this.put(5700, 37);
                this.put(5800, 31);
                this.put(5900, 30);
                this.put(6000, 39);
                this.put(6100, 29);
                this.put(6200, 40);
                this.put(6300, 36);
                this.put(6400, 42);
                this.put(6500, 39);
                this.put(6600, 28);
                this.put(6700, 38);
                this.put(6800, 34);
                this.put(6900, 23);
                this.put(7000, 25);
                this.put(7100, 32);
                this.put(7200, 19);
                this.put(7300, 21);
                this.put(7400, 23);
                this.put(7500, 26);
                this.put(7600, 24);
                this.put(7700, 18);
                this.put(7800, 19);
                this.put(7900, 30);
                this.put(8000, 21);
                this.put(8100, 21);
                this.put(8200, 21);
                this.put(8300, 13);
                this.put(8400, 18);
                this.put(8500, 14);
                this.put(8600, 19);
                this.put(8700, 21);
                this.put(8800, 14);
                this.put(8900, 19);
                this.put(9000, 25);
                this.put(9100, 12);
                this.put(9200, 16);
                this.put(9300, 13);
                this.put(9400, 21);
                this.put(9500, 18);
                this.put(9600, 25);
                this.put(9700, 17);
                this.put(9800, 15);
                this.put(9900, 21);
                this.put(10000, 151);
                this.put(11000, 143);
                this.put(12000, 122);
                this.put(13000, 97);
                this.put(14000, 103);
                this.put(15000, 135);
                this.put(16000, 84);
                this.put(17000, 63);
                this.put(18000, 92);
                this.put(19000, 81);
                this.put(20000, 98);
                this.put(21000, 133);
                this.put(22000, 67);
                this.put(23000, 63);
                this.put(24000, 66);
                this.put(25000, 53);
                this.put(26000, 85);
                this.put(27000, 67);
                this.put(28000, 90);
                this.put(29000, 60);
                this.put(30000, 48);
                this.put(31000, 34);
                this.put(32000, 35);
                this.put(33000, 59);
                this.put(34000, 40);
                this.put(35000, 56);
                this.put(36000, 68);
                this.put(37000, 40);
                this.put(38000, 37);
                this.put(39000, 33);
                this.put(40000, 34);
                this.put(41000, 28);
                this.put(42000, 35);
                this.put(43000, 37);
                this.put(44000, 34);
                this.put(45000, 55);
                this.put(46000, 30);
                this.put(47000, 34);
                this.put(48000, 30);
                this.put(49000, 15);
                this.put(50000, 14);
                this.put(51000, 40);
                this.put(52000, 16);
                this.put(53000, 36);
                this.put(54000, 19);
                this.put(55000, 17);
                this.put(56000, 20);
                this.put(57000, 24);
                this.put(58000, 29);
                this.put(59000, 36);
                this.put(60000, 34);
                this.put(61000, 26);
                this.put(62000, 20);
                this.put(63000, 14);
                this.put(64000, 12);
                this.put(65000, 17);
                this.put(66000, 8);
                this.put(67000, 20);
                this.put(68000, 17);
                this.put(69000, 20);
                this.put(70000, 11);
                this.put(71000, 8);
                this.put(72000, 5);
                this.put(73000, 11);
                this.put(74000, 20);
                this.put(75000, 8);
                this.put(76000, 8);
                this.put(77000, 29);
                this.put(78000, 5);
                this.put(79000, 4);
                this.put(80000, 7);
                this.put(81000, 5);
                this.put(82000, 8);
                this.put(83000, 4);
                this.put(84000, 5);
                this.put(85000, 5);
                this.put(86000, 10);
                this.put(87000, 8);
                this.put(88000, 7);
                this.put(90000, 1);
                this.put(91000, 5);
                this.put(92000, 4);
                this.put(93000, 16);
                this.put(94000, 11);
                this.put(95000, 3);
                this.put(96000, 5);
                this.put(97000, 6);
                this.put(98000, 2);
                this.put(99000, 5);
                this.put(100000, 4);
            }
        },
        new ObjectHistogram<Integer>() {
            {
                this.put(-10000, 15);
                this.put(-9900, 19);
                this.put(-9800, 20);
                this.put(-9700, 17);
                this.put(-9600, 25);
                this.put(-9500, 19);
                this.put(-9400, 21);
                this.put(-9300, 18);
                this.put(-9200, 20);
                this.put(-9100, 14);
                this.put(-9000, 28);
                this.put(-8900, 19);
                this.put(-8800, 16);
                this.put(-8700, 17);
                this.put(-8600, 21);
                this.put(-8500, 15);
                this.put(-8400, 17);
                this.put(-8300, 21);
                this.put(-8200, 28);
                this.put(-8100, 24);
                this.put(-8000, 23);
                this.put(-7900, 37);
                this.put(-7800, 24);
                this.put(-7700, 27);
                this.put(-7600, 34);
                this.put(-7500, 33);
                this.put(-7400, 22);
                this.put(-7300, 24);
                this.put(-7200, 30);
                this.put(-7100, 40);
                this.put(-7000, 40);
                this.put(-6900, 38);
                this.put(-6800, 50);
                this.put(-6700, 36);
                this.put(-6600, 38);
                this.put(-6500, 44);
                this.put(-6400, 31);
                this.put(-6300, 41);
                this.put(-6200, 38);
                this.put(-6100, 31);
                this.put(-6000, 40);
                this.put(-5900, 45);
                this.put(-5800, 43);
                this.put(-5700, 54);
                this.put(-5600, 37);
                this.put(-5500, 58);
                this.put(-5400, 57);
                this.put(-5300, 65);
                this.put(-5200, 75);
                this.put(-5100, 67);
                this.put(-5000, 58);
                this.put(-4900, 63);
                this.put(-4800, 69);
                this.put(-4700, 73);
                this.put(-4600, 60);
                this.put(-4500, 59);
                this.put(-4400, 76);
                this.put(-4300, 76);
                this.put(-4200, 72);
                this.put(-4100, 87);
                this.put(-4000, 92);
                this.put(-3900, 101);
                this.put(-3800, 97);
                this.put(-3700, 74);
                this.put(-3600, 117);
                this.put(-3500, 100);
                this.put(-3400, 124);
                this.put(-3300, 112);
                this.put(-3200, 128);
                this.put(-3100, 141);
                this.put(-3000, 152);
                this.put(-2900, 134);
                this.put(-2800, 156);
                this.put(-2700, 155);
                this.put(-2600, 148);
                this.put(-2500, 194);
                this.put(-2400, 198);
                this.put(-2300, 224);
                this.put(-2200, 257);
                this.put(-2100, 280);
                this.put(-2000, 325);
                this.put(-1900, 318);
                this.put(-1800, 385);
                this.put(-1700, 367);
                this.put(-1600, 436);
                this.put(-1500, 483);
                this.put(-1400, 506);
                this.put(-1300, 586);
                this.put(-1200, 643);
                this.put(-1100, 791);
                this.put(-1000, 650);
                this.put(-900, 721);
                this.put(-800, 909);
                this.put(-700, 1148);
                this.put(-600, 1363);
                this.put(-500, 1819);
                this.put(-400, 2635);
                this.put(-300, 4395);
                this.put(-200, 8706);
                this.put(-100, 36354);
                this.put(0, 344441);
                this.put(100, 110948);
                this.put(200, 33273);
                this.put(300, 18915);
                this.put(400, 11943);
                this.put(500, 8587);
                this.put(600, 6339);
                this.put(700, 4763);
                this.put(800, 3813);
                this.put(900, 2773);
                this.put(1000, 2302);
                this.put(1100, 1802);
                this.put(1200, 1445);
                this.put(1300, 1397);
                this.put(1400, 1644);
                this.put(1500, 1156);
                this.put(1600, 728);
                this.put(1700, 801);
                this.put(1800, 605);
                this.put(1900, 485);
                this.put(2000, 504);
                this.put(2100, 432);
                this.put(2200, 324);
                this.put(2300, 288);
                this.put(2400, 301);
                this.put(2500, 312);
                this.put(2600, 201);
                this.put(2700, 171);
                this.put(2800, 134);
                this.put(2900, 148);
                this.put(3000, 157);
                this.put(3100, 126);
                this.put(3200, 117);
                this.put(3300, 103);
                this.put(3400, 112);
                this.put(3500, 97);
                this.put(3600, 93);
                this.put(3700, 77);
                this.put(3800, 69);
                this.put(3900, 55);
                this.put(4000, 86);
                this.put(4100, 65);
                this.put(4200, 68);
                this.put(4300, 74);
                this.put(4400, 39);
                this.put(4500, 44);
                this.put(4600, 51);
                this.put(4700, 46);
                this.put(4800, 48);
                this.put(4900, 41);
                this.put(5000, 38);
                this.put(5100, 33);
                this.put(5200, 59);
                this.put(5300, 39);
                this.put(5400, 23);
                this.put(5500, 39);
                this.put(5600, 37);
                this.put(5700, 30);
                this.put(5800, 34);
                this.put(5900, 28);
                this.put(6000, 16);
                this.put(6100, 25);
                this.put(6200, 25);
                this.put(6300, 33);
                this.put(6400, 23);
                this.put(6500, 27);
                this.put(6600, 19);
                this.put(6700, 27);
                this.put(6800, 26);
                this.put(6900, 20);
                this.put(7000, 19);
                this.put(7100, 16);
                this.put(7200, 13);
                this.put(7300, 10);
                this.put(7400, 17);
                this.put(7500, 13);
                this.put(7600, 18);
                this.put(7700, 25);
                this.put(7800, 19);
                this.put(7900, 8);
                this.put(8000, 13);
                this.put(8100, 10);
                this.put(8200, 12);
                this.put(8300, 7);
                this.put(8400, 8);
                this.put(8500, 8);
                this.put(8600, 12);
                this.put(8700, 8);
                this.put(8800, 9);
                this.put(8900, 9);
                this.put(9000, 13);
                this.put(9100, 4);
                this.put(9200, 10);
                this.put(9300, 14);
                this.put(9400, 13);
                this.put(9500, 11);
                this.put(9600, 10);
                this.put(9700, 5);
                this.put(9800, 9);
                this.put(9900, 8);
                this.put(10000, 63);
                this.put(11000, 57);
                this.put(12000, 43);
                this.put(13000, 45);
                this.put(14000, 43);
                this.put(15000, 23);
                this.put(16000, 26);
                this.put(17000, 29);
                this.put(18000, 21);
                this.put(19000, 20);
                this.put(20000, 20);
                this.put(21000, 13);
                this.put(22000, 21);
                this.put(23000, 18);
                this.put(24000, 10);
                this.put(25000, 10);
                this.put(26000, 13);
                this.put(27000, 12);
                this.put(28000, 13);
                this.put(29000, 6);
                this.put(30000, 6);
                this.put(31000, 11);
                this.put(32000, 9);
                this.put(33000, 8);
                this.put(34000, 8);
                this.put(35000, 4);
                this.put(36000, 4);
                this.put(37000, 1);
                this.put(38000, 5);
                this.put(39000, 3);
                this.put(40000, 3);
                this.put(41000, 2);
                this.put(42000, 2);
                this.put(43000, 6);
                this.put(44000, 4);
                this.put(45000, 9);
                this.put(46000, 6);
                this.put(47000, 5);
                this.put(48000, 5);
                this.put(49000, 5);
                this.put(50000, 3);
                this.put(51000, 5);
                this.put(52000, 4);
                this.put(53000, 6);
                this.put(54000, 2);
                this.put(55000, 1);
                this.put(56000, 3);
                this.put(57000, 2);
                this.put(60000, 2);
                this.put(61000, 5);
                this.put(63000, 2);
                this.put(65000, 1);
                this.put(68000, 3);
                this.put(69000, 1);
                this.put(70000, 1);
                this.put(71000, 1);
                this.put(72000, 1);
                this.put(73000, 4);
                this.put(75000, 3);
                this.put(76000, 1);
                this.put(77000, 2);
                this.put(78000, 1);
                this.put(80000, 1);
                this.put(81000, 5);
                this.put(82000, 1);
                this.put(83000, 1);
                this.put(84000, 2);
                this.put(88000, 2);
                this.put(91000, 1);
                this.put(93000, 3);
                this.put(97000, 2);
                this.put(99000, 4);
                this.put(100000, 1);
            }
        },
        new ObjectHistogram<Integer>() {
            {
                this.put(-985000, 1);
                this.put(-982000, 1);
                this.put(-950000, 1);
                this.put(-944000, 1);
                this.put(-852000, 1);
                this.put(-801000, 1);
                this.put(-800000, 1);
                this.put(-749000, 1);
                this.put(-719000, 1);
                this.put(-711000, 1);
                this.put(-696000, 1);
                this.put(-687000, 2);
                this.put(-683000, 1);
                this.put(-681000, 1);
                this.put(-667000, 1);
                this.put(-644000, 1);
                this.put(-643000, 1);
                this.put(-642000, 1);
                this.put(-634000, 1);
                this.put(-596000, 1);
                this.put(-512000, 1);
                this.put(-486000, 2);
                this.put(-481000, 1);
                this.put(-450000, 1);
                this.put(-445000, 3);
                this.put(-433000, 1);
                this.put(-418000, 1);
                this.put(-391000, 1);
                this.put(-386000, 1);
                this.put(-382000, 2);
                this.put(-376000, 1);
                this.put(-364000, 1);
                this.put(-359000, 2);
                this.put(-357000, 1);
                this.put(-344000, 1);
                this.put(-332000, 1);
                this.put(-331000, 1);
                this.put(-328000, 1);
                this.put(-327000, 1);
                this.put(-326000, 1);
                this.put(-323000, 1);
                this.put(-319000, 3);
                this.put(-317000, 1);
                this.put(-312000, 2);
                this.put(-300000, 1);
                this.put(-299000, 1);
                this.put(-295000, 1);
                this.put(-292000, 1);
                this.put(-289000, 1);
                this.put(-284000, 1);
                this.put(-275000, 1);
                this.put(-273000, 2);
                this.put(-269000, 1);
                this.put(-261000, 1);
                this.put(-260000, 1);
                this.put(-258000, 1);
                this.put(-256000, 5);
                this.put(-252000, 1);
                this.put(-251000, 2);
                this.put(-250000, 1);
                this.put(-249000, 1);
                this.put(-248000, 1);
                this.put(-247000, 2);
                this.put(-246000, 2);
                this.put(-245000, 2);
                this.put(-239000, 4);
                this.put(-232000, 2);
                this.put(-229000, 1);
                this.put(-227000, 1);
                this.put(-224000, 2);
                this.put(-219000, 1);
                this.put(-218000, 1);
                this.put(-217000, 3);
                this.put(-216000, 2);
                this.put(-214000, 2);
                this.put(-213000, 1);
                this.put(-209000, 1);
                this.put(-208000, 2);
                this.put(-207000, 1);
                this.put(-205000, 2);
                this.put(-203000, 2);
                this.put(-201000, 9);
                this.put(-200000, 3);
                this.put(-199000, 1);
                this.put(-197000, 1);
                this.put(-192000, 1);
                this.put(-191000, 3);
                this.put(-190000, 3);
                this.put(-189000, 1);
                this.put(-188000, 1);
                this.put(-187000, 1);
                this.put(-186000, 1);
                this.put(-185000, 2);
                this.put(-184000, 6);
                this.put(-183000, 5);
                this.put(-181000, 3);
                this.put(-180000, 1);
                this.put(-176000, 1);
                this.put(-175000, 1);
                this.put(-174000, 3);
                this.put(-173000, 1);
                this.put(-172000, 4);
                this.put(-171000, 4);
                this.put(-170000, 1);
                this.put(-169000, 2);
                this.put(-167000, 3);
                this.put(-166000, 1);
                this.put(-165000, 1);
                this.put(-164000, 6);
                this.put(-163000, 1);
                this.put(-162000, 6);
                this.put(-161000, 12);
                this.put(-160000, 5);
                this.put(-159000, 1);
                this.put(-158000, 3);
                this.put(-157000, 2);
                this.put(-156000, 2);
                this.put(-155000, 1);
                this.put(-154000, 6);
                this.put(-153000, 5);
                this.put(-152000, 2);
                this.put(-151000, 3);
                this.put(-150000, 2);
                this.put(-149000, 1);
                this.put(-148000, 1);
                this.put(-147000, 1);
                this.put(-146000, 4);
                this.put(-144000, 1);
                this.put(-143000, 3);
                this.put(-142000, 2);
                this.put(-141000, 2);
                this.put(-140000, 6);
                this.put(-139000, 5);
                this.put(-138000, 4);
                this.put(-137000, 4);
                this.put(-136000, 7);
                this.put(-134000, 10);
                this.put(-133000, 4);
                this.put(-132000, 1);
                this.put(-131000, 3);
                this.put(-128000, 2);
                this.put(-127000, 7);
                this.put(-126000, 4);
                this.put(-124000, 1);
                this.put(-122000, 7);
                this.put(-121000, 3);
                this.put(-120000, 2);
                this.put(-119000, 2);
                this.put(-118000, 4);
                this.put(-117000, 3);
                this.put(-116000, 3);
                this.put(-115000, 3);
                this.put(-114000, 2);
                this.put(-113000, 4);
                this.put(-112000, 4);
                this.put(-111000, 4);
                this.put(-110000, 3);
                this.put(-109000, 3);
                this.put(-108000, 2);
                this.put(-107000, 3);
                this.put(-106000, 6);
                this.put(-105000, 3);
                this.put(-104000, 2);
                this.put(-103000, 3);
                this.put(-102000, 3);
                this.put(-101000, 6);
                this.put(-100000, 10);
                this.put(-99000, 2);
                this.put(-98000, 10);
                this.put(-97000, 5);
                this.put(-96000, 6);
                this.put(-95000, 14);
                this.put(-94000, 19);
                this.put(-93000, 12);
                this.put(-92000, 9);
                this.put(-91000, 4);
                this.put(-90000, 2);
                this.put(-89000, 11);
                this.put(-88000, 7);
                this.put(-87000, 12);
                this.put(-86000, 7);
                this.put(-85000, 8);
                this.put(-84000, 13);
                this.put(-83000, 17);
                this.put(-82000, 15);
                this.put(-81000, 15);
                this.put(-80000, 6);
                this.put(-79000, 10);
                this.put(-78000, 30);
                this.put(-77000, 18);
                this.put(-76000, 13);
                this.put(-75000, 20);
                this.put(-74000, 14);
                this.put(-73000, 12);
                this.put(-72000, 9);
                this.put(-71000, 12);
                this.put(-70000, 24);
                this.put(-69000, 28);
                this.put(-68000, 22);
                this.put(-67000, 17);
                this.put(-66000, 17);
                this.put(-65000, 17);
                this.put(-64000, 13);
                this.put(-63000, 29);
                this.put(-62000, 38);
                this.put(-61000, 35);
                this.put(-60000, 39);
                this.put(-59000, 33);
                this.put(-58000, 32);
                this.put(-57000, 22);
                this.put(-56000, 26);
                this.put(-55000, 20);
                this.put(-54000, 53);
                this.put(-53000, 23);
                this.put(-52000, 47);
                this.put(-51000, 34);
                this.put(-50000, 24);
                this.put(-49000, 40);
                this.put(-48000, 52);
                this.put(-47000, 38);
                this.put(-46000, 67);
                this.put(-45000, 51);
                this.put(-44000, 41);
                this.put(-43000, 51);
                this.put(-42000, 47);
                this.put(-41000, 49);
                this.put(-40000, 45);
                this.put(-39000, 54);
                this.put(-38000, 62);
                this.put(-37000, 83);
                this.put(-36000, 85);
                this.put(-35000, 66);
                this.put(-34000, 71);
                this.put(-33000, 64);
                this.put(-32000, 56);
                this.put(-31000, 79);
                this.put(-30000, 77);
                this.put(-29000, 119);
                this.put(-28000, 129);
                this.put(-27000, 110);
                this.put(-26000, 91);
                this.put(-25000, 99);
                this.put(-24000, 116);
                this.put(-23000, 136);
                this.put(-22000, 167);
                this.put(-21000, 160);
                this.put(-20000, 137);
                this.put(-19000, 156);
                this.put(-18000, 129);
                this.put(-17000, 159);
                this.put(-16000, 216);
                this.put(-15000, 226);
                this.put(-14000, 197);
                this.put(-13000, 278);
                this.put(-12000, 308);
                this.put(-11000, 336);
                this.put(-10000, 17);
                this.put(-9900, 24);
                this.put(-9800, 19);
                this.put(-9700, 15);
                this.put(-9600, 25);
                this.put(-9500, 25);
                this.put(-9400, 33);
                this.put(-9300, 20);
                this.put(-9200, 23);
                this.put(-9100, 29);
                this.put(-9000, 30);
                this.put(-8900, 25);
                this.put(-8800, 27);
                this.put(-8700, 23);
                this.put(-8600, 26);
                this.put(-8500, 29);
                this.put(-8400, 26);
                this.put(-8300, 24);
                this.put(-8200, 28);
                this.put(-8100, 33);
                this.put(-8000, 21);
                this.put(-7900, 23);
                this.put(-7800, 33);
                this.put(-7700, 25);
                this.put(-7600, 27);
                this.put(-7500, 35);
                this.put(-7400, 28);
                this.put(-7300, 28);
                this.put(-7200, 32);
                this.put(-7100, 37);
                this.put(-7000, 25);
                this.put(-6900, 35);
                this.put(-6800, 44);
                this.put(-6700, 37);
                this.put(-6600, 34);
                this.put(-6500, 28);
                this.put(-6400, 43);
                this.put(-6300, 47);
                this.put(-6200, 43);
                this.put(-6100, 46);
                this.put(-6000, 47);
                this.put(-5900, 55);
                this.put(-5800, 55);
                this.put(-5700, 51);
                this.put(-5600, 63);
                this.put(-5500, 50);
                this.put(-5400, 63);
                this.put(-5300, 51);
                this.put(-5200, 65);
                this.put(-5100, 64);
                this.put(-5000, 78);
                this.put(-4900, 90);
                this.put(-4800, 63);
                this.put(-4700, 84);
                this.put(-4600, 81);
                this.put(-4500, 73);
                this.put(-4400, 61);
                this.put(-4300, 104);
                this.put(-4200, 72);
                this.put(-4100, 72);
                this.put(-4000, 95);
                this.put(-3900, 112);
                this.put(-3800, 96);
                this.put(-3700, 111);
                this.put(-3600, 111);
                this.put(-3500, 110);
                this.put(-3400, 139);
                this.put(-3300, 143);
                this.put(-3200, 179);
                this.put(-3100, 160);
                this.put(-3000, 173);
                this.put(-2900, 161);
                this.put(-2800, 168);
                this.put(-2700, 155);
                this.put(-2600, 236);
                this.put(-2500, 197);
                this.put(-2400, 205);
                this.put(-2300, 238);
                this.put(-2200, 246);
                this.put(-2100, 306);
                this.put(-2000, 333);
                this.put(-1900, 275);
                this.put(-1800, 315);
                this.put(-1700, 349);
                this.put(-1600, 369);
                this.put(-1500, 460);
                this.put(-1400, 435);
                this.put(-1300, 524);
                this.put(-1200, 618);
                this.put(-1100, 630);
                this.put(-1000, 802);
                this.put(-900, 942);
                this.put(-800, 1107);
                this.put(-700, 1423);
                this.put(-600, 1838);
                this.put(-500, 2325);
                this.put(-400, 3243);
                this.put(-300, 5065);
                this.put(-200, 9760);
                this.put(-100, 34478);
                this.put(0, 259217);
                this.put(100, 84193);
                this.put(200, 35121);
                this.put(300, 22719);
                this.put(400, 14995);
                this.put(500, 10444);
                this.put(600, 7718);
                this.put(700, 5715);
                this.put(800, 4569);
                this.put(900, 3470);
                this.put(1000, 2788);
                this.put(1100, 2287);
                this.put(1200, 1907);
                this.put(1300, 1698);
                this.put(1400, 1632);
                this.put(1500, 1232);
                this.put(1600, 976);
                this.put(1700, 906);
                this.put(1800, 770);
                this.put(1900, 644);
                this.put(2000, 672);
                this.put(2100, 584);
                this.put(2200, 541);
                this.put(2300, 452);
                this.put(2400, 401);
                this.put(2500, 372);
                this.put(2600, 331);
                this.put(2700, 279);
                this.put(2800, 255);
                this.put(2900, 254);
                this.put(3000, 216);
                this.put(3100, 190);
                this.put(3200, 204);
                this.put(3300, 178);
                this.put(3400, 166);
                this.put(3500, 165);
                this.put(3600, 147);
                this.put(3700, 127);
                this.put(3800, 119);
                this.put(3900, 126);
                this.put(4000, 121);
                this.put(4100, 90);
                this.put(4200, 90);
                this.put(4300, 107);
                this.put(4400, 72);
                this.put(4500, 89);
                this.put(4600, 76);
                this.put(4700, 96);
                this.put(4800, 59);
                this.put(4900, 84);
                this.put(5000, 70);
                this.put(5100, 53);
                this.put(5200, 61);
                this.put(5300, 65);
                this.put(5400, 51);
                this.put(5500, 63);
                this.put(5600, 58);
                this.put(5700, 43);
                this.put(5800, 53);
                this.put(5900, 55);
                this.put(6000, 48);
                this.put(6100, 46);
                this.put(6200, 49);
                this.put(6300, 43);
                this.put(6400, 36);
                this.put(6500, 25);
                this.put(6600, 29);
                this.put(6700, 24);
                this.put(6800, 34);
                this.put(6900, 27);
                this.put(7000, 28);
                this.put(7100, 29);
                this.put(7200, 27);
                this.put(7300, 26);
                this.put(7400, 36);
                this.put(7500, 38);
                this.put(7600, 24);
                this.put(7700, 22);
                this.put(7800, 23);
                this.put(7900, 24);
                this.put(8000, 23);
                this.put(8100, 28);
                this.put(8200, 18);
                this.put(8300, 12);
                this.put(8400, 26);
                this.put(8500, 12);
                this.put(8600, 19);
                this.put(8700, 17);
                this.put(8800, 18);
                this.put(8900, 20);
                this.put(9000, 17);
                this.put(9100, 21);
                this.put(9200, 24);
                this.put(9300, 15);
                this.put(9400, 15);
                this.put(9500, 11);
                this.put(9600, 16);
                this.put(9700, 21);
                this.put(9800, 14);
                this.put(9900, 17);
                this.put(10000, 140);
                this.put(11000, 123);
                this.put(12000, 120);
                this.put(13000, 83);
                this.put(14000, 67);
                this.put(15000, 53);
                this.put(16000, 54);
                this.put(17000, 43);
                this.put(18000, 37);
                this.put(19000, 39);
                this.put(20000, 30);
                this.put(21000, 30);
                this.put(22000, 41);
                this.put(23000, 21);
                this.put(24000, 12);
                this.put(25000, 21);
                this.put(26000, 17);
                this.put(27000, 15);
                this.put(28000, 27);
                this.put(29000, 12);
                this.put(30000, 8);
                this.put(31000, 23);
                this.put(32000, 13);
                this.put(33000, 11);
                this.put(34000, 8);
                this.put(35000, 11);
                this.put(36000, 8);
                this.put(37000, 12);
                this.put(38000, 8);
                this.put(39000, 17);
                this.put(40000, 8);
                this.put(41000, 5);
                this.put(42000, 9);
                this.put(43000, 4);
                this.put(44000, 6);
                this.put(45000, 1);
                this.put(46000, 5);
                this.put(47000, 7);
                this.put(48000, 3);
                this.put(49000, 5);
                this.put(50000, 13);
                this.put(51000, 1);
                this.put(52000, 3);
                this.put(53000, 5);
                this.put(54000, 3);
                this.put(55000, 4);
                this.put(57000, 2);
                this.put(59000, 2);
                this.put(60000, 2);
                this.put(61000, 4);
                this.put(62000, 4);
                this.put(63000, 1);
                this.put(64000, 2);
                this.put(65000, 1);
                this.put(66000, 7);
                this.put(67000, 1);
                this.put(68000, 2);
                this.put(69000, 4);
                this.put(70000, 2);
                this.put(71000, 1);
                this.put(72000, 3);
                this.put(73000, 1);
                this.put(74000, 1);
                this.put(75000, 1);
                this.put(76000, 2);
                this.put(77000, 1);
                this.put(78000, 2);
                this.put(79000, 2);
                this.put(80000, 1);
                this.put(81000, 1);
                this.put(82000, 2);
                this.put(83000, 11);
                this.put(84000, 2);
                this.put(85000, 1);
                this.put(87000, 3);
                this.put(88000, 1);
                this.put(89000, 1);
                this.put(90000, 1);
                this.put(92000, 6);
                this.put(93000, 1);
                this.put(94000, 2);
                this.put(97000, 1);
                this.put(98000, 1);
                this.put(100000, 1);
            }
        }
    };
    
    /**
     * The histogram of the REV_MINOR_EDIT column
     */
    public static final ObjectHistogram<Integer> MINOR_EDIT = new ObjectHistogram<Integer>() {
        {
            this.put(0, 1142822);
            this.put(1, 362171);
        }
    };
    
}
